Gentoo Archives: gentoo-commits

From: "Robin H. Johnson (robbat2)" <robbat2@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] gentoo-x86 commit in dev-vcs/git: ChangeLog git-1.7.3.5-r1.ebuild
Date: Thu, 06 Jan 2011 20:40:59
Message-Id: 20110106204046.4CBF720051@flycatcher.gentoo.org
1 robbat2 11/01/06 20:40:46
2
3 Modified: ChangeLog
4 Added: git-1.7.3.5-r1.ebuild
5 Log:
6 Bug #320647 redux: Full ability to disable Python usage for Prefix (needed to work around circular dependency loop).
7
8 (Portage version: 2.2.0_alpha13/cvs/Linux x86_64)
9
10 Revision Changes Path
11 1.70 dev-vcs/git/ChangeLog
12
13 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.70&view=markup
14 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.70&content-type=text/plain
15 diff : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?r1=1.69&r2=1.70
16
17 Index: ChangeLog
18 ===================================================================
19 RCS file: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v
20 retrieving revision 1.69
21 retrieving revision 1.70
22 diff -p -w -b -B -u -u -r1.69 -r1.70
23 --- ChangeLog 6 Jan 2011 04:01:55 -0000 1.69
24 +++ ChangeLog 6 Jan 2011 20:40:46 -0000 1.70
25 @@ -1,6 +1,12 @@
26 # ChangeLog for dev-vcs/git
27 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
28 -# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.69 2011/01/06 04:01:55 robbat2 Exp $
29 +# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.70 2011/01/06 20:40:46 robbat2 Exp $
30 +
31 +*git-1.7.3.5-r1 (06 Jan 2011)
32 +
33 + 06 Jan 2011; Robin H. Johnson <robbat2@g.o> +git-1.7.3.5-r1.ebuild:
34 + Bug #320647 redux: Full ability to disable Python usage for Prefix (needed to
35 + work around circular dependency loop).
36
37 *git-1.7.4_rc1 (06 Jan 2011)
38
39
40
41
42 1.1 dev-vcs/git/git-1.7.3.5-r1.ebuild
43
44 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.7.3.5-r1.ebuild?rev=1.1&view=markup
45 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.7.3.5-r1.ebuild?rev=1.1&content-type=text/plain
46
47 Index: git-1.7.3.5-r1.ebuild
48 ===================================================================
49 # Copyright 1999-2011 Gentoo Foundation
50 # Distributed under the terms of the GNU General Public License v2
51 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.7.3.5-r1.ebuild,v 1.1 2011/01/06 20:40:46 robbat2 Exp $
52
53 EAPI=3
54
55 GENTOO_DEPEND_ON_PERL=no
56 inherit toolchain-funcs eutils elisp-common perl-module bash-completion
57 [ "$PV" == "9999" ] && inherit git
58
59 MY_PV="${PV/_rc/.rc}"
60 MY_P="${PN}-${MY_PV}"
61
62 DOC_VER=${MY_PV}
63
64 DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
65 HOMEPAGE="http://www.git-scm.com/"
66 if [ "$PV" != "9999" ]; then
67 SRC_URI="mirror://kernel/software/scm/git/${MY_P}.tar.bz2
68 mirror://kernel/software/scm/git/${PN}-manpages-${DOC_VER}.tar.bz2
69 doc? ( mirror://kernel/software/scm/git/${PN}-htmldocs-${DOC_VER}.tar.bz2 )"
70 KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~sparc-fbsd ~x86-fbsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
71 else
72 SRC_URI=""
73 EGIT_BRANCH="master"
74 EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
75 # EGIT_REPO_URI="http://www.kernel.org/pub/scm/git/git.git"
76 KEYWORDS=""
77 fi
78
79 LICENSE="GPL-2"
80 SLOT="0"
81 IUSE="+blksha1 +curl cgi doc emacs gtk iconv +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion"
82
83 # Common to both DEPEND and RDEPEND
84 CDEPEND="
85 !blksha1? ( dev-libs/openssl )
86 sys-libs/zlib
87 perl? ( dev-lang/perl[-build] )
88 python? ( dev-lang/python )
89 tk? ( dev-lang/tk )
90 curl? (
91 net-misc/curl
92 webdav? ( dev-libs/expat )
93 )
94 emacs? ( virtual/emacs )"
95
96 RDEPEND="${CDEPEND}
97 perl? ( dev-perl/Error
98 dev-perl/Net-SMTP-SSL
99 dev-perl/Authen-SASL
100 cgi? ( virtual/perl-CGI )
101 cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
102 subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
103 )
104 python? ( gtk?
105 (
106 >=dev-python/pygtk-2.8
107 || ( dev-python/pygtksourceview:2 dev-python/gtksourceview-python )
108 ) )"
109
110 # This is how info docs are created with Git:
111 # .txt/asciidoc --(asciidoc)---------> .xml/docbook
112 # .xml/docbook --(docbook2texi.pl)--> .texi
113 # .texi --(makeinfo)---------> .info
114 DEPEND="${CDEPEND}
115 app-arch/cpio
116 doc? (
117 app-text/asciidoc
118 app-text/docbook2X
119 sys-apps/texinfo
120 )"
121
122 # Live ebuild builds man pages and HTML docs, additionally
123 if [ "$PV" == "9999" ]; then
124 DEPEND="${DEPEND}
125 app-text/asciidoc
126 app-text/xmlto"
127 fi
128
129 SITEFILE=50${PN}-gentoo.el
130 S="${WORKDIR}/${MY_P}"
131
132 pkg_setup() {
133 if ! use perl ; then
134 use cgi && ewarn "gitweb needs USE=perl, ignoring USE=cgi"
135 use cvs && ewarn "CVS integration needs USE=perl, ignoring USE=cvs"
136 use subversion && ewarn "git-svn needs USE=perl, it won't work"
137 fi
138 if use webdav && ! use curl ; then
139 ewarn "USE=webdav needs USE=curl. Ignoring"
140 fi
141 if use subversion && has_version dev-vcs/subversion && built_with_use --missing false dev-vcs/subversion dso ; then
142 ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
143 ewarn "with USE=dso, there may be weird crashes in git-svn. You"
144 ewarn "have been warned."
145 fi
146 }
147
148 # This is needed because for some obscure reasons future calls to make don't
149 # pick up these exports if we export them in src_unpack()
150 exportmakeopts() {
151 local myopts
152
153 if use blksha1 ; then
154 myopts="${myopts} BLK_SHA1=YesPlease"
155 elif use ppcsha1 ; then
156 myopts="${myopts} PPC_SHA1=YesPlease"
157 fi
158
159 if use curl ; then
160 use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
161 else
162 myopts="${myopts} NO_CURL=YesPlease"
163 fi
164
165 # broken assumptions, because of broken build system ...
166 myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
167 myopts="${myopts} INSTALL=install TAR=tar"
168 myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
169 myopts="${myopts} SANE_TOOL_PATH="
170 myopts="${myopts} OLD_ICONV="
171 myopts="${myopts} NO_EXTERNAL_GREP="
172
173 # can't define this to null, since the entire makefile depends on it
174 sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
175
176 use iconv \
177 || einfo "Forcing iconv for ${PVR} due to bugs #321895, #322205."
178 # || myopts="${myopts} NO_ICONV=YesPlease"
179 # because, above, we need to do this unconditionally (no "&& use iconv")
180 use !elibc_glibc && myopts="${myopts} NEEDS_LIBICONV=YesPlease"
181
182 use tk \
183 || myopts="${myopts} NO_TCLTK=YesPlease"
184 use perl \
185 && myopts="${myopts} INSTALLDIRS=vendor" \
186 || myopts="${myopts} NO_PERL=YesPlease"
187 use python \
188 || myopts="${myopts} NO_PYTHON=YesPlease"
189 use subversion \
190 || myopts="${myopts} NO_SVN_TESTS=YesPlease"
191 use threads \
192 && myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease"
193 # Disabled until ~m68k-mint can be keyworded again
194 # if [[ ${CHOST} == *-mint* ]] ; then
195 # myopts="${myopts} NO_MMAP=YesPlease"
196 # myopts="${myopts} NO_IPV6=YesPlease"
197 # myopts="${myopts} NO_STRLCPY=YesPlease"
198 # myopts="${myopts} NO_MEMMEM=YesPlease"
199 # myopts="${myopts} NO_MKDTEMP=YesPlease"
200 # myopts="${myopts} NO_MKSTEMPS=YesPlease"
201 # fi
202 if [[ ${CHOST} == ia64-*-hpux* ]]; then
203 myopts="${myopts} NO_NSEC=YesPlease"
204 fi
205
206 has_version '>=app-text/asciidoc-8.0' \
207 && myopts="${myopts} ASCIIDOC8=YesPlease"
208 myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
209
210 # Bug 290465:
211 # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
212 [[ "${CHOST}" == *-uclibc* ]] && \
213 myopts="${myopts} NO_NSEC=YesPlease"
214
215 export MY_MAKEOPTS="${myopts}"
216 }
217
218 src_unpack() {
219 if [ "${PV}" != "9999" ]; then
220 unpack ${MY_P}.tar.bz2
221 cd "${S}"
222 unpack ${PN}-manpages-${DOC_VER}.tar.bz2
223 use doc && \
224 cd "${S}"/Documentation && \
225 unpack ${PN}-htmldocs-${DOC_VER}.tar.bz2
226 cd "${S}"
227 else
228 git_src_unpack
229 cd "${S}"
230 #cp "${FILESDIR}"/GIT-VERSION-GEN .
231 fi
232
233 }
234
235 src_prepare() {
236 # Noperl is being merged to upstream as of 2009/04/05
237 #epatch "${FILESDIR}"/20090305-git-1.6.2-noperl.patch
238
239 # GetOpt-Long v2.38 is strict
240 # Merged in 1.6.3 final 2009/05/07
241 #epatch "${FILESDIR}"/20090505-git-1.6.2.5-getopt-fixes.patch
242
243 # JS install fixup
244 epatch "${FILESDIR}"/git-1.7.2-always-install-js.patch
245
246 # USE=-iconv causes segfaults, fixed post 1.7.1
247 # Gentoo bug #321895
248 #epatch "${FILESDIR}"/git-1.7.1-noiconv-segfault-fix.patch
249
250 # Fix false positives with t3404 due to SHELL=/bin/false for the portage
251 # user.
252 # Merged upstream
253 #epatch "${FILESDIR}"/git-1.7.3.4-avoid-shell-issues.patch
254
255 # bug #350075: t9001: fix missing prereq on some tests
256 # Merged upstream
257 #epatch "${FILESDIR}"/git-1.7.3.4-fix-perl-test-prereq.patch
258
259 sed -i \
260 -e 's:^\(CFLAGS =\).*$:\1 $(OPTCFLAGS) -Wall:' \
261 -e 's:^\(LDFLAGS =\).*$:\1 $(OPTLDFLAGS):' \
262 -e 's:^\(CC = \).*$:\1$(OPTCC):' \
263 -e 's:^\(AR = \).*$:\1$(OPTAR):' \
264 -e "s:\(PYTHON_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
265 -e "s:\(PERL_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
266 Makefile || die "sed failed"
267
268 # Never install the private copy of Error.pm (bug #296310)
269 sed -i \
270 -e '/private-Error.pm/s,^,#,' \
271 perl/Makefile.PL
272
273 # Fix docbook2texi command
274 sed -i 's/DOCBOOK2X_TEXI=docbook2x-texi/DOCBOOK2X_TEXI=docbook2texi.pl/' \
275 Documentation/Makefile || die "sed failed"
276
277 # bug #318289
278 epatch "${FILESDIR}"/git-1.7.3.2-interix.patch
279 }
280
281 git_emake() {
282 # bug #326625: PERL_PATH, PERL_MM_OPT
283 # bug #320647: PYTHON_PATH
284 PYTHON_PATH=""
285 use python && PYTHON_PATH="${EPREFIX}/usr/bin/python"
286 emake ${MY_MAKEOPTS} \
287 DESTDIR="${D}" \
288 OPTCFLAGS="${CFLAGS}" \
289 OPTLDFLAGS="${LDFLAGS}" \
290 OPTCC="$(tc-getCC)" \
291 OPTAR="$(tc-getAR)" \
292 prefix="${EPREFIX}"/usr \
293 htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
294 sysconfdir="${EPREFIX}"/etc \
295 PYTHON_PATH="${PYTHON_PATH}" \
296 PERL_PATH="${EPREFIX}/usr/bin/env perl" \
297 PERL_MM_OPT="" \
298 GIT_TEST_OPTS="--no-color" \
299 "$@"
300 }
301
302 src_configure() {
303 exportmakeopts
304 }
305
306 src_compile() {
307 git_emake || die "emake failed"
308
309 if use emacs ; then
310 elisp-compile contrib/emacs/git{,-blame}.el \
311 || die "emacs modules failed"
312 fi
313
314 if use perl && use cgi ; then
315 git_emake \
316 gitweb/gitweb.cgi \
317 || die "emake gitweb/gitweb.cgi failed"
318 fi
319
320 cd "${S}"/Documentation
321 if [[ "$PV" == "9999" ]] ; then
322 git_emake man \
323 || die "emake man failed"
324 if use doc ; then
325 git_emake info html \
326 || die "emake info html failed"
327 fi
328 else
329 if use doc ; then
330 git_emake info \
331 || die "emake info html failed"
332 fi
333 fi
334 }
335
336 src_install() {
337 git_emake \
338 install || \
339 die "make install failed"
340
341 # Depending on the tarball and manual rebuild of the documentation, the
342 # manpages may exist in either OR both of these directories.
343 find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
344 find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
345
346 dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
347 use doc && dodir /usr/share/doc/${PF}/html
348 for d in / /howto/ /technical/ ; do
349 docinto ${d}
350 dodoc Documentation${d}*.txt
351 use doc && dohtml -p ${d} Documentation${d}*.html
352 done
353 docinto /
354 # Upstream does not ship this pre-built :-(
355 use doc && doinfo Documentation/{git,gitman}.info
356
357 dobashcompletion contrib/completion/git-completion.bash ${PN}
358
359 if use emacs ; then
360 elisp-install ${PN} contrib/emacs/git.{el,elc} || die
361 elisp-install ${PN} contrib/emacs/git-blame.{el,elc} || die
362 #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc} || die
363 # don't add automatically to the load-path, so the sitefile
364 # can do a conditional loading
365 touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
366 elisp-site-file-install "${FILESDIR}"/${SITEFILE} || die
367 fi
368
369 if use python && use gtk ; then
370 dobin "${S}"/contrib/gitview/gitview
371 dodoc "${S}"/contrib/gitview/gitview.txt
372 fi
373
374 dobin contrib/fast-import/git-p4
375 dodoc contrib/fast-import/git-p4.txt
376 newbin contrib/fast-import/import-tars.perl import-tars
377 newbin contrib/git-resurrect.sh git-resurrect
378
379 dodir /usr/share/${PN}/contrib
380 # The following are excluded:
381 # completion - installed above
382 # emacs - installed above
383 # examples - these are stuff that is not used in Git anymore actually
384 # gitview - installed above
385 # p4import - excluded because fast-import has a better one
386 # patches - stuff the Git guys made to go upstream to other places
387 # svnimport - use git-svn
388 # thunderbird-patch-inline - fixes thunderbird
389 for i in \
390 blameview buildsystems ciabot continuous convert-objects fast-import \
391 hg-to-git hooks remotes2config.sh remotes2config.sh rerere-train.sh \
392 stats svn-fe vim workdir \
393 ; do
394 cp -rf \
395 "${S}"/contrib/${i} \
396 "${ED}"/usr/share/${PN}/contrib \
397 || die "Failed contrib ${i}"
398 done
399
400 if use perl && use cgi ; then
401 # We used to install in /usr/share/${PN}/gitweb
402 # but upstream installs in /usr/share/gitweb
403 # so we will install a symlink and use their location for compat with other
404 # distros
405 dosym /usr/share/gitweb /usr/share/${PN}/gitweb
406
407 # INSTALL discusses configuration issues, not just installation
408 docinto /
409 newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
410 newdoc "${S}"/gitweb/README README.gitweb
411
412 find "${ED}"/usr/lib64/perl5/ \
413 -name .packlist \
414 -exec rm \{\} \;
415 else
416 rm -rf "${D}"/usr/share/gitweb
417 fi
418
419 if ! use subversion ; then
420 rm -f "${ED}"/usr/libexec/git-core/git-svn \
421 "${ED}"/usr/share/man/man1/git-svn.1*
422 fi
423
424 if use xinetd ; then
425 insinto /etc/xinetd.d
426 newins "${FILESDIR}"/git-daemon.xinetd git-daemon
427 fi
428
429 newinitd "${FILESDIR}"/git-daemon.initd git-daemon
430 newconfd "${FILESDIR}"/git-daemon.confd git-daemon
431
432 fixlocalpod
433 }
434
435 src_test() {
436 local disabled=""
437 local tests_cvs="t9200-git-cvsexportcommit.sh \
438 t9400-git-cvsserver-server.sh \
439 t9401-git-cvsserver-crlf.sh \
440 t9600-cvsimport.sh \
441 t9601-cvsimport-vendor-branch.sh \
442 t9602-cvsimport-branches-tags.sh \
443 t9603-cvsimport-patchsets.sh"
444 local tests_perl="t5502-quickfetch.sh \
445 t5512-ls-remote.sh \
446 t5520-pull.sh"
447 # Bug #225601 - t0004 is not suitable for root perm
448 # Bug #219839 - t1004 is not suitable for root perm
449 # t0001-init.sh - check for init notices EPERM* fails
450 local tests_nonroot="t0001-init.sh \
451 t0004-unwritable.sh \
452 t1004-read-tree-m-u-wf.sh \
453 t3700-add.sh \
454 t7300-clean.sh"
455
456 # Unzip is used only for the testcase code, not by any normal parts of Git.
457 if ! has_version app-arch/unzip ; then
458 einfo "Disabling tar-tree tests"
459 disabled="${disabled} t5000-tar-tree.sh"
460 fi
461
462 cvs=0
463 use cvs && let cvs=$cvs+1
464 if [[ ${EUID} -eq 0 ]]; then
465 if [[ $cvs -eq 1 ]]; then
466 ewarn "Skipping CVS tests because CVS does not work as root!"
467 ewarn "You should retest with FEATURES=userpriv!"
468 disabled="${disabled} ${tests_cvs}"
469 fi
470 einfo "Skipping other tests that require being non-root"
471 disabled="${disabled} ${tests_nonroot}"
472 else
473 [[ $cvs -gt 0 ]] && \
474 has_version dev-vcs/cvs && \
475 let cvs=$cvs+1
476 [[ $cvs -gt 1 ]] && \
477 built_with_use dev-vcs/cvs server && \
478 let cvs=$cvs+1
479 if [[ $cvs -lt 3 ]]; then
480 einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
481 disabled="${disabled} ${tests_cvs}"
482 fi
483 fi
484
485 if ! use perl ; then
486 einfo "Disabling tests that need Perl"
487 disabled="${disabled} ${tests_perl}"
488 fi
489
490 # Reset all previously disabled tests
491 cd "${S}/t"
492 for i in *.sh.DISABLED ; do
493 [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
494 done
495 einfo "Disabled tests:"
496 for i in ${disabled} ; do
497 [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
498 done
499
500 # Avoid the test system removing the results because we want them ourselves
501 sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
502 -i "${S}"/t/Makefile
503
504 # Clean old results first
505 cd "${S}/t"
506 git_emake clean
507
508 # Now run the tests
509 cd "${S}"
510 einfo "Start test run"
511 git_emake test
512 rc=$?
513
514 # Display nice results
515 cd "${S}/t"
516 git_emake aggregate-results
517
518 # And exit
519 [ $rc -eq 0 ] || die "tests failed. Please file a bug."
520 }
521
522 showpkgdeps() {
523 local pkg=$1
524 shift
525 elog " $(printf "%-17s:" ${pkg}) ${@}"
526 }
527
528 pkg_postinst() {
529 use emacs && elisp-site-regen
530 if use subversion && has_version dev-vcs/subversion && ! built_with_use --missing false dev-vcs/subversion perl ; then
531 ewarn "You must build dev-vcs/subversion with USE=perl"
532 ewarn "to get the full functionality of git-svn!"
533 fi
534 elog "These additional scripts need some dependencies:"
535 echo
536 showpkgdeps git-quiltimport "dev-util/quilt"
537 showpkgdeps git-instaweb \
538 "|| ( www-servers/lighttpd www-servers/apache )"
539 echo
540 }
541
542 pkg_postrm() {
543 use emacs && elisp-site-regen
544 }